"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Init = void 0;
const clone_1 = require("./clone");
const check_1 = require("./check");
class Init {
    static route(r, parentPath) {
        check_1.Check.leadSlash(r.path);
        const route = clone_1.Clone.route(r);
        route.path = Init.path(route.path, parentPath);
        route.redirectTo = Init.to(route.redirectTo, parentPath);
        route.customTo = Init.customTo(route.customTo, parentPath);
        route.children = Init.children(route);
        return route;
    }
    static path(path, parentPath) {
        if (path === '') {
            return parentPath;
        }
        else {
            const prefix = parentPath === '/' ? '' : parentPath;
            return prefix + '/' + path;
        }
    }
    static to(to, parentPath) {
        if (typeof to === 'string') {
            if (to === '')
                return parentPath;
            else if (to[0] === '/')
                return to;
            else {
                const prefix = parentPath === '/' ? '/' : parentPath + '/';
                return prefix + to;
            }
        }
    }
    static customTo(to, parentPath) {
        if (to) {
            to.pathname = Init.to(to.pathname, parentPath);
            return to;
        }
    }
    static children({ path: parentPath, children }) {
        return children?.map(route => Init.route(route, parentPath));
    }
}
exports.Init = Init;
